/*
 * This file is a part of fmtx-faker: Tricks fmtxd into thinking the transmitter is not disabled.
 *
 * Copyright (C) 2009-2010 Faheem Pervez <trippin1@gmail.com>. All rights reserved.
 *
 *             DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *                   Version 2, December 2004
 *
 *	Copyright (C) 2004 Sam Hocevar
 *	14 rue de Plaisance, 75014 Paris, France
 *	Everyone is permitted to copy and distribute verbatim or modified
 *	copies of this license document, and changing it is allowed as long
 *	as the name is changed.
 *
 *           DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
 *  TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
 *
 * 	0. You just DO WHAT THE FUCK YOU WANT TO. 
 *
 * This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details.
 *
 *  gcc fmtx-faker-preemp-tool.c `pkg-config --cflags --libs libcal glib-2.0` -Wall
 */
 
/* fmtx-faker-preemp-tool.c */ 

/* This is not finished, not by a long shot. I've omitted the write support because I do not know if it is safe to do so! */

#include <stdlib.h>
#include <cal.h>
#include <glib.h>

/* static gboolean write = FALSE; --this should be a gchar

static GOptionEntry entries[] = 
{
	{"write", 'w', 0, G_OPTION_ARG_NONE, &write, "Write the given value to CAL", NULL},
	{NULL}
}; */

static void save_rd_flags (void)
{
	struct cal *cal_s;
	GString *rd_mode_string_buf;
	guint i;
	gchar rd_mode_string = '\0';

	/* g_printerr ("%s\n", __PRETTY_FUNCTION__); */

	if (cal_init (&cal_s) < 0)
	{
		g_printerr ("Failed to init CAL.\n");
		exit (EXIT_FAILURE);
	}

	if (cal_write_block (cal_s, "r&d_mode", &rd_mode_string, sizeof (rd_mode_string), CAL_FLAG_USER) < 0)
	{
        	cal_finish (cal_s);
		g_printerr ("Failed to write to the r&d mode area in CAL.\n");
		exit (EXIT_FAILURE);
	}


	if (!hildon_check_button_get_active (HILDON_CHECK_BUTTON (check_button[MASTER])))
	{
		cal_finish (cal_s);
		return;
	}
	
	rd_mode_string_buf = g_string_new (rd_mode_flags[MASTER]);

	for (i = 1; i < NUM; i++)
	{
		if (hildon_check_button_get_active (HILDON_CHECK_BUTTON (check_button[i])))
		{
			gchar *combined_text = g_strconcat (",", rd_mode_flags[i], NULL);
			g_string_append (rd_mode_string_buf, combined_text);
			g_free (combined_text);
		}
	}

	if (cal_write_block(cal_s, "r&d_mode", rd_mode_string_buf->str, strlen (rd_mode_string_buf->str) + 1, CAL_FLAG_USER) < 0)
	{
        	cal_finish (cal_s);
                g_string_free (rd_mode_string_buf, TRUE);
		g_printerr ("Failed to write to the r&d mode area in CAL.\n");
		exit (EXIT_FAILURE);
	}

	g_string_free (rd_mode_string_buf, TRUE);

	cal_finish (cal_s);
}

static void read_rd_flags (void)
{
	struct cal *cal_s;
	void *tmp = NULL;
	char *rd_mode_string;
	unsigned long len;
	guint i;

	if (cal_init (&cal_s) < 0)
	{
		g_printerr ("Failed to init CAL.\n");
		exit (EXIT_FAILURE);
	}

	if (cal_read_block (cal_s, "r&d_mode", &tmp, &len, CAL_FLAG_USER) < 0)
	{
        	cal_finish (cal_s);
		g_printerr ("Failed to read r&d mode area from CAL.\n");
		exit (EXIT_FAILURE);
	}

	if (len < 1 && !rd_mode_string)
	{
        	cal_finish (cal_s);
		g_printerr ("Failed to read r&d mode settings from CAL.\n");
		exit (EXIT_FAILURE);
	}

	rd_mode_string = (char *) tmp;

	for (i = 0; i < NUM; i++)
	{
		if (strstr (rd_mode_string, rd_mode_flags[i]))
			hildon_check_button_set_active (HILDON_CHECK_BUTTON (check_button[i]), TRUE);
	}

	free (rd_mode_string);

    	cal_finish (cal_s);
}

gint main (gint argc, gchar *argv[])
{
	
}
